<?php
/**
 * @package MachII
 */
/**
 * EventCommand class.
 * 
 * The base EventCommand class.
 * @package MachII
 * @author Ben Edwards <ben@ben-edwards.com>
 * @author Alan Richmond <alan@aardwolfweb.com>
 */
abstract class MachII_framework_EventCommand
{
    /**
     * Parameters
     * 
     * EventCommand parameters are set via the configuration file.
     * @access private
     * @var array associative array
     */
    private $_parameters = array();
    
    
    /**
     * @abstract
     * @param MachII_framework_Event
     * @param MachII_framework_EventContext
     */
    public abstract function execute(MachII_framework_Event $event, MachII_framework_EventContext $eventContext);
    
    /**
     * @param string
     * @param mixed
     */
    public function setParameter($name, $value)
    {
        $this->_parameters[$name] = $value;
    }
    
    /**
     * @param string
     * @return string
     */
    public function getParameter($name)
    {
        return $this->_parameters[$name];
    }
    
    /**
     * @access protected
     * @param array associative array will be merged with any existing parameters
     */
    protected  function setParameters($parameters)
    {
        $this->_parameters = array_merge($this->_parameters, $parameters);
    }

}

?>
